

-- NB: This code is best viewed with tab size set to two spaces --


--[[ Plugin entry point ]]--

_G.printDebug = false;

-- Import Turbine Classes

import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

-- Determine Locale
_G.locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	_G.locale = "de";
elseif Turbine.Shell.IsCommand("aide") then
	_G.locale = "fr";
end
import ("CombatAnalysis.Locale."..locale);

-- Import Utils & UI
import "CombatAnalysis.Utils";
import "CombatAnalysis.UI";

-- Import Other Helper Classes
import "CombatAnalysis.Data";
import "CombatAnalysis.Players";
import "CombatAnalysis.Parser";

-- Import Main Menu and Help Menu
import "CombatAnalysis.Menu"; --- v4.1
-- import "CombatAnalysis.Help"; --- v4.13+ (maybe never)

-- Import Each Individual Plugin Package
import "CombatAnalysis.StatOverview";     --- v4.0
import "CombatAnalysis.Effects";          --- v4.1 (for BuffBars Debuff/CC tracking)
-- import "CombatAnalysis.StatAnalysis";  --- v4.2+
-- import "CombatAnalysis.FloatyInfo";    --- v4.2/3+
-- import "CombatAnalysis.StatRecording"; --- (possible future feature)
-- import "CombatAnalysis.ChatFiltering"; --- (possible future feature)
-- import "CombatAnalysis.HealingBars";   --- (possible future feature)
-- import "CombatAnalysis.GearScore";     --- (possible future feature)

-- Set up Plugin unload event
Plugins["CombatAnalysis"].Unload = function()
	Turbine.Shell.RemoveCommand(UpdateCommand);
	
	menuPane:SetParent(nil);
	menuPane:SetVisible(false);
	-- NB: unfortunately, the reference still persists & can crash the game on plugin apartment unload
end

--[[ Start up ]]--

-- Print the Welcome Message (the version number is extracted automatically)
Turbine.Shell.WriteLine("Combat Analysis v"..versionNo.." by Evendale"..
	--(locale == "fr" and " (traduction fr by ??)" or
	  (locale == "de" and " (de \195\156bersetzung von Dero/Amtholdiel)"
	or ""));

-- Initialize the list of running buffs on the player
InitializeRunningBuffs();

-- Initialize the global combat data object (create "Totals" encounter with timestamp)
combatData:Initialize();

-- Load Settings which will create all relevant windows
LoadSettings();

-- Load the Data Files List to assist with loading/saving
LoadDataList();

